/* S/390-32 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000-2008-2011, 2014 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of either:

  * the GNU Lesser General Public License as published by the Free
    Software Foundation; either version 3 of the License, or (at your
    option) any later version.

or

  * the GNU General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any
    later version.

or both in parallel, as here.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received copies of the GNU General Public License and the
GNU Lesser General Public License along with the GNU MP Library.  If not,
see https://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 32
#define GMP_LIMB_BYTES 4

/* 4400 MHz IBM z10 running in 32-bit mode */
/* FFT tuning limit = 15000000 */
/* Generated by tuneup.c, 2014-03-12, gcc 4.7 */

#define DIVREM_1_NORM_THRESHOLD              3
#define DIVREM_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define MOD_1_1P_METHOD                      1
#define MOD_1_NORM_THRESHOLD                 4
#define MOD_1_UNNORM_THRESHOLD               8
#define MOD_1N_TO_MOD_1_1_THRESHOLD         16
#define MOD_1U_TO_MOD_1_1_THRESHOLD          8
#define MOD_1_1_TO_MOD_1_2_THRESHOLD         0  /* never mpn_mod_1_1p */
#define MOD_1_2_TO_MOD_1_4_THRESHOLD        38
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD     30
#define USE_PREINV_DIVREM_1                  1
#define DIV_QR_1N_PI1_METHOD                 1
#define DIV_QR_1_NORM_THRESHOLD              3
#define DIV_QR_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define DIV_QR_2_PI2_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define DIVEXACT_1_THRESHOLD                 0  /* always */
#define BMOD_1_TO_MOD_1_THRESHOLD           56

#define MUL_TOOM22_THRESHOLD                 8
#define MUL_TOOM33_THRESHOLD                59
#define MUL_TOOM44_THRESHOLD                88
#define MUL_TOOM6H_THRESHOLD               125
#define MUL_TOOM8H_THRESHOLD               169

#define MUL_TOOM32_TO_TOOM43_THRESHOLD      57
#define MUL_TOOM32_TO_TOOM53_THRESHOLD      55
#define MUL_TOOM42_TO_TOOM53_THRESHOLD      57
#define MUL_TOOM42_TO_TOOM63_THRESHOLD      56
#define MUL_TOOM43_TO_TOOM54_THRESHOLD      82

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 14
#define SQR_TOOM3_THRESHOLD                 90
#define SQR_TOOM4_THRESHOLD                144
#define SQR_TOOM6_THRESHOLD                196
#define SQR_TOOM8_THRESHOLD                309

#define MULMID_TOOM42_THRESHOLD             24

#define MULMOD_BNM1_THRESHOLD               12
#define SQRMOD_BNM1_THRESHOLD               10

#define MUL_FFT_MODF_THRESHOLD             252  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    252, 5}, {      9, 6}, {      5, 5}, {     13, 6}, \
    {      7, 5}, {     15, 6}, {     13, 7}, {      7, 6}, \
    {     15, 7}, {      9, 6}, {     19, 7}, {     11, 6}, \
    {     23, 7}, {     13, 8}, {      7, 7}, {     15, 6}, \
    {     31, 7}, {     19, 8}, {     11, 7}, {     23, 9}, \
    {      7, 8}, {     15, 7}, {     31, 8}, {     19, 7}, \
    {     39, 8}, {     27, 9}, {     15, 8}, {     39, 9}, \
    {     23,10}, {     15, 9}, {     31, 8}, {     63, 9}, \
    {     39, 8}, {     79, 9}, {     47,10}, {     31, 9}, \
    {     79,10}, {     47,11}, {     31,10}, {     63, 9}, \
    {    127, 8}, {    255,10}, {     79, 8}, {    319, 9}, \
    {    175, 8}, {    351, 7}, {    703, 6}, {   1407,10}, \
    {     95, 9}, {    191, 8}, {    383, 9}, {    207, 8}, \
    {    415, 7}, {    831, 9}, {    223,11}, {     63,10}, \
    {    127, 9}, {    255,10}, {    143, 9}, {    287, 8}, \
    {    575, 9}, {    319,10}, {    175, 9}, {    351, 8}, \
    {    703, 7}, {   1407,11}, {     95,10}, {    191, 9}, \
    {    383,10}, {    207, 9}, {    415, 8}, {    831,12}, \
    {     63,11}, {    127,10}, {    255, 9}, {    575,11}, \
    {    159,10}, {    351, 9}, {    703, 8}, {   1407,11}, \
    {    191,10}, {    415, 9}, {    831,11}, {    223,10}, \
    {    447, 9}, {    895, 8}, {   1791,10}, {    479, 9}, \
    {    959,12}, {    127,11}, {    287,10}, {    575,11}, \
    {    351,10}, {    703, 9}, {   1407,12}, {    191,11}, \
    {    415,10}, {    831,11}, {    447,10}, {    895, 9}, \
    {   1791,11}, {    479,10}, {    959,13}, {    127,12}, \
    {    255,11}, {    575,12}, {    319,11}, {    703,10}, \
    {   1407,12}, {    383,11}, {    831,12}, {    447,11}, \
    {    895,10}, {   1791,11}, {    959,10}, {   1919, 9}, \
    {   3839,13}, {    255,12}, {    575,11}, {   1215,10}, \
    {   2431,12}, {    703,11}, {   1407,13}, {    383,12}, \
    {    895,11}, {   1791,12}, {    959,11}, {   1919,10}, \
    {   3839,14}, {    255,13}, {    511,12}, {   1215,11}, \
    {   2431,13}, {    639,12}, {   1471,13}, {    895,12}, \
    {   1919,11}, {   3839,10}, {   7679,14}, {    511,13}, \
    {   1023,12}, {   2047,13}, {   1151,12}, {   2431,13}, \
    {   1407,14}, {    767,13}, {   8192,14}, {  16384,15}, \
    {  32768,16} }
#define MUL_FFT_TABLE3_SIZE 149
#define MUL_FFT_THRESHOLD                 2240

#define SQR_FFT_MODF_THRESHOLD             244  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    244, 5}, {     11, 6}, {      6, 5}, {     13, 6}, \
    {      7, 5}, {     15, 6}, {      8, 5}, {     17, 6}, \
    {     11, 5}, {     23, 6}, {     13, 7}, {      7, 6}, \
    {     16, 7}, {      9, 6}, {     19, 7}, {     11, 6}, \
    {     23, 7}, {     13, 8}, {      7, 7}, {     19, 8}, \
    {     11, 7}, {     23, 9}, {      7, 8}, {     15, 7}, \
    {     31, 8}, {     19, 7}, {     39, 8}, {     23, 9}, \
    {     15, 8}, {     39, 9}, {     23,10}, {     15, 9}, \
    {     31, 8}, {     63, 9}, {     39, 8}, {     79, 9}, \
    {     47,10}, {     31, 9}, {     63, 8}, {    127, 9}, \
    {     71, 8}, {    143, 7}, {    287,10}, {     47,11}, \
    {     31,10}, {     63, 9}, {    127, 8}, {    255, 9}, \
    {    143, 8}, {    287,10}, {     79, 9}, {    159, 8}, \
    {    319, 9}, {    175, 8}, {    351, 7}, {    703, 6}, \
    {   1407,10}, {     95, 9}, {    191, 8}, {    383,11}, \
    {     63,10}, {    127, 9}, {    255,10}, {    143, 9}, \
    {    287, 8}, {    575,10}, {    159, 9}, {    319,10}, \
    {    175, 9}, {    351, 8}, {    703, 7}, {   1407,11}, \
    {     95,10}, {    191, 9}, {    383,10}, {    207,12}, \
    {     63,11}, {    127,10}, {    255, 9}, {    511,10}, \
    {    287, 9}, {    575,11}, {    159,10}, {    351, 9}, \
    {    703, 8}, {   1407,11}, {    191,10}, {    415,11}, \
    {    223,10}, {    447, 9}, {    895, 8}, {   1791,10}, \
    {    479, 9}, {    959,12}, {    127,11}, {    255,10}, \
    {    511,11}, {    287,10}, {    575,11}, {    319,10}, \
    {    639,11}, {    351,10}, {    703, 9}, {   1407,12}, \
    {    191,11}, {    415,10}, {    831,11}, {    447,10}, \
    {    895, 9}, {   1791,11}, {    479,13}, {    127,12}, \
    {    255,11}, {    575,12}, {    319,11}, {    703,10}, \
    {   1407,12}, {    383,11}, {    831,12}, {    447,11}, \
    {    895,10}, {   1791,11}, {    959,10}, {   1919,13}, \
    {    255,12}, {    511,11}, {   1023,12}, {    575,11}, \
    {   1215,10}, {   2431,12}, {    703,11}, {   1407,13}, \
    {    383,12}, {    895,11}, {   1791,12}, {    959,11}, \
    {   1919,14}, {    255,13}, {    511,12}, {   1215,11}, \
    {   2431,13}, {    639,12}, {   1471,11}, {   2943,10}, \
    {   5887,13}, {    895,12}, {   1919,11}, {   3839,10}, \
    {   7679,14}, {    511,13}, {   1023,12}, {   2047,13}, \
    {   1151,12}, {   2431,13}, {   1407,12}, {   2943,11}, \
    {   5887,14}, {    767,13}, {   8192,14}, {  16384,15}, \
    {  32768,16} }
#define SQR_FFT_TABLE3_SIZE 161
#define SQR_FFT_THRESHOLD                 1728

#define MULLO_BASECASE_THRESHOLD             0  /* always */
#define MULLO_DC_THRESHOLD                  33
#define MULLO_MUL_N_THRESHOLD             4392

#define DC_DIV_QR_THRESHOLD                 43
#define DC_DIVAPPR_Q_THRESHOLD             150
#define DC_BDIV_QR_THRESHOLD                38
#define DC_BDIV_Q_THRESHOLD                107

#define INV_MULMOD_BNM1_THRESHOLD           14
#define INV_NEWTON_THRESHOLD               165
#define INV_APPR_THRESHOLD                 149

#define BINV_NEWTON_THRESHOLD              147
#define REDC_1_TO_REDC_N_THRESHOLD          43

#define MU_DIV_QR_THRESHOLD                777
#define MU_DIVAPPR_Q_THRESHOLD             942
#define MUPI_DIV_QR_THRESHOLD               69
#define MU_BDIV_QR_THRESHOLD               654
#define MU_BDIV_Q_THRESHOLD                777

#define POWM_SEC_TABLE  3,32,126,692,1486

#define MATRIX22_STRASSEN_THRESHOLD         17
#define HGCD_THRESHOLD                     103
#define HGCD_APPR_THRESHOLD                144
#define HGCD_REDUCE_THRESHOLD             1437
#define GCD_DC_THRESHOLD                   275
#define GCDEXT_DC_THRESHOLD                206
#define JACOBI_BASE_METHOD                   4

#define GET_STR_DC_THRESHOLD                 9
#define GET_STR_PRECOMPUTE_THRESHOLD        20
#define SET_STR_DC_THRESHOLD               532
#define SET_STR_PRECOMPUTE_THRESHOLD       999

#define FAC_DSC_THRESHOLD                  156
#define FAC_ODD_THRESHOLD                   24
