/* AMD bd2 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000-2005, 2008-2010, 2014 Free Software
Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of either:

  * the GNU Lesser General Public License as published by the Free
    Software Foundation; either version 3 of the License, or (at your
    option) any later version.

or

  * the GNU General Public License as published by the Free Software
    Foundation; either version 2 of the License, or (at your option) any
    later version.

or both in parallel, as here.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received copies of the GNU General Public License and the
GNU Lesser General Public License along with the GNU MP Library.  If not,
see https://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 32
#define GMP_LIMB_BYTES 4

/* 3600 MHz Bulldozer Zambezi */
/* FFT tuning limit = 25000000 */
/* Generated by tuneup.c, 2014-03-13, gcc 4.5 */

#define MOD_1_NORM_THRESHOLD                 0  /* always */
#define MOD_1_UNNORM_THRESHOLD               3
#define MOD_1N_TO_MOD_1_1_THRESHOLD          7
#define MOD_1U_TO_MOD_1_1_THRESHOLD          4
#define MOD_1_1_TO_MOD_1_2_THRESHOLD        16
#define MOD_1_2_TO_MOD_1_4_THRESHOLD         0  /* never mpn_mod_1s_2p */
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD     11
#define USE_PREINV_DIVREM_1                  1  /* native */
#define DIV_QR_1N_PI1_METHOD                 1
#define DIV_QR_1_NORM_THRESHOLD              3
#define DIV_QR_1_UNNORM_THRESHOLD        MP_SIZE_T_MAX  /* never */
#define DIV_QR_2_PI2_THRESHOLD           MP_SIZE_T_MAX  /* never */
#define DIVEXACT_1_THRESHOLD                 0  /* always (native) */
#define BMOD_1_TO_MOD_1_THRESHOLD           27

#define MUL_TOOM22_THRESHOLD                32
#define MUL_TOOM33_THRESHOLD                65
#define MUL_TOOM44_THRESHOLD               154
#define MUL_TOOM6H_THRESHOLD               230
#define MUL_TOOM8H_THRESHOLD               354

#define MUL_TOOM32_TO_TOOM43_THRESHOLD      89
#define MUL_TOOM32_TO_TOOM53_THRESHOLD     110
#define MUL_TOOM42_TO_TOOM53_THRESHOLD      93
#define MUL_TOOM42_TO_TOOM63_THRESHOLD     102
#define MUL_TOOM43_TO_TOOM54_THRESHOLD     130

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 48
#define SQR_TOOM3_THRESHOLD                 87
#define SQR_TOOM4_THRESHOLD                204
#define SQR_TOOM6_THRESHOLD                315
#define SQR_TOOM8_THRESHOLD                430

#define MULMID_TOOM42_THRESHOLD             48

#define MULMOD_BNM1_THRESHOLD               21
#define SQRMOD_BNM1_THRESHOLD               23

#define MUL_FFT_MODF_THRESHOLD             840  /* k = 5 */
#define MUL_FFT_TABLE3                                      \
  { {    840, 5}, {     28, 6}, {     15, 5}, {     33, 6}, \
    {     28, 7}, {     15, 6}, {     32, 7}, {     17, 6}, \
    {     35, 7}, {     19, 6}, {     39, 7}, {     23, 6}, \
    {     47, 7}, {     29, 8}, {     15, 7}, {     31, 6}, \
    {     63, 7}, {     35, 8}, {     19, 7}, {     41, 8}, \
    {     23, 7}, {     51, 8}, {     27, 7}, {     55, 8}, \
    {     31, 7}, {     63, 8}, {     39, 7}, {     79, 9}, \
    {     23, 8}, {     55, 9}, {     31, 8}, {     67, 9}, \
    {     39, 8}, {     79, 9}, {     47, 8}, {     95, 9}, \
    {     55,10}, {     31, 9}, {     63, 8}, {    127, 9}, \
    {     79,10}, {     47, 9}, {    103,11}, {     31,10}, \
    {     63, 9}, {    135,10}, {     79, 9}, {    159,10}, \
    {     95, 9}, {    191,10}, {    111,11}, {     63,10}, \
    {    127, 9}, {    255,10}, {    159,11}, {     95,10}, \
    {    191,12}, {     63,11}, {    127,10}, {    271,11}, \
    {    159,10}, {    319, 9}, {    639,11}, {    191,10}, \
    {    383, 9}, {    767,11}, {    223,12}, {    127,11}, \
    {    255,10}, {    511,11}, {    287,10}, {    607,11}, \
    {    319,10}, {    639,12}, {    191,11}, {    383,10}, \
    {    799,13}, {    127,12}, {    255,11}, {    543,10}, \
    {   1087,11}, {    607,12}, {    319,11}, {    671,10}, \
    {   1343,11}, {    735,10}, {   1471, 9}, {   2943,12}, \
    {    383,11}, {    799,10}, {   1599,11}, {    863,10}, \
    {   1727,12}, {    447,13}, {    255,12}, {    511,11}, \
    {   1087,12}, {    575,11}, {   1215,10}, {   2431,12}, \
    {    639,11}, {   1343,12}, {    703,11}, {   1471,10}, \
    {   2943,13}, {    383,12}, {    767,11}, {   1599,12}, \
    {    831,11}, {   1727,10}, {   3455,14}, {    255,13}, \
    {    511,12}, {   1087,11}, {   2239,12}, {   1215,11}, \
    {   2431,13}, {    639,12}, {   1471,11}, {   2943,13}, \
    {    767,12}, {   1727,11}, {   3455,13}, {    895,12}, \
    {   1919,11}, {   3839,12}, {   1983,11}, {   3967,10}, \
    {   7935,14}, {    511,13}, {   1023,12}, {   2239,13}, \
    {   1151,12}, {   2495,11}, {   4991,13}, {   1279,12}, \
    {   2623,13}, {   1407,12}, {   2943,14}, {    767,13}, \
    {   1535,12}, {   3071,13}, {   1663,12}, {   3455,13}, \
    {   1791,12}, {   3583,13}, {   1919,12}, {   3967,11}, \
    {   7935,15}, {    511,14}, {   1023,13}, {   2175,12}, \
    {   4479,13}, {   2431,12}, {   4991,14}, {   1279,13}, \
    {   2943,12}, {   6015,14}, {  16384,15}, {  32768,16} }
#define MUL_FFT_TABLE3_SIZE 160
#define MUL_FFT_THRESHOLD                 7808

#define SQR_FFT_MODF_THRESHOLD             690  /* k = 5 */
#define SQR_FFT_TABLE3                                      \
  { {    690, 5}, {     28, 6}, {     15, 5}, {     32, 6}, \
    {     29, 7}, {     15, 6}, {     33, 7}, {     17, 6}, \
    {     35, 7}, {     19, 6}, {     40, 7}, {     21, 6}, \
    {     43, 7}, {     23, 6}, {     47, 7}, {     35, 8}, \
    {     19, 7}, {     43, 8}, {     23, 7}, {     49, 8}, \
    {     27, 7}, {     55, 8}, {     31, 7}, {     63, 8}, \
    {     39, 7}, {     79, 8}, {     43, 9}, {     23, 8}, \
    {     55, 9}, {     31, 8}, {     67, 9}, {     39, 8}, \
    {     79, 9}, {     47, 8}, {     95, 9}, {     55,10}, \
    {     31, 9}, {     63, 8}, {    127, 9}, {     79,10}, \
    {     47, 9}, {     95,11}, {     31,10}, {     63, 9}, \
    {    127,10}, {     79, 9}, {    167,10}, {     95, 9}, \
    {    191,10}, {    111,11}, {     63,10}, {    159,11}, \
    {     95,10}, {    191,12}, {     63,11}, {    127,10}, \
    {    271,11}, {    159,10}, {    319, 9}, {    639,11}, \
    {    191,10}, {    383,11}, {    223,12}, {    127,11}, \
    {    255,10}, {    511, 9}, {   1023,10}, {    543,11}, \
    {    287,10}, {    607, 9}, {   1215,11}, {    319,10}, \
    {    639,12}, {    191,11}, {    383,10}, {    799,11}, \
    {    415,13}, {    127,12}, {    255,11}, {    511,10}, \
    {   1023,11}, {    543,10}, {   1087,11}, {    607,10}, \
    {   1215,12}, {    319,11}, {    671,10}, {   1343,11}, \
    {    735,10}, {   1471,12}, {    383,11}, {    799,10}, \
    {   1599,11}, {    863,12}, {    447,11}, {    927,13}, \
    {    255,12}, {    511,11}, {   1055,10}, {   2111,11}, \
    {   1087,12}, {    575,11}, {   1215,10}, {   2431,12}, \
    {    639,11}, {   1343,12}, {    703,11}, {   1471,13}, \
    {    383,12}, {    767,11}, {   1599,12}, {    831,11}, \
    {   1727,10}, {   3455,12}, {    895,14}, {    255,13}, \
    {    511,12}, {   1023,11}, {   2111,12}, {   1087,11}, \
    {   2239,10}, {   4479,12}, {   1215,11}, {   2431,13}, \
    {    639,12}, {   1471,11}, {   2943,13}, {    767,12}, \
    {   1727,11}, {   3455,13}, {    895,12}, {   1983,11}, \
    {   3967,14}, {    511,13}, {   1023,12}, {   2239,11}, \
    {   4479,13}, {   1151,12}, {   2495,11}, {   4991,10}, \
    {   9983,13}, {   1279,12}, {   2623,13}, {   1407,12}, \
    {   2943,14}, {    767,13}, {   1663,12}, {   3455,13}, \
    {   1791,12}, {   3583,13}, {   1919,12}, {   3967,15}, \
    {    511,14}, {   1023,13}, {   2175,12}, {   4479,13}, \
    {   2431,12}, {   4991,11}, {   9983,14}, {   1279,13}, \
    {   2687,12}, {   5375,13}, {   2943,12}, {   5887,14}, \
    {  16384,15}, {  32768,16} }
#define SQR_FFT_TABLE3_SIZE 166
#define SQR_FFT_THRESHOLD                 6784

#define MULLO_BASECASE_THRESHOLD             5
#define MULLO_DC_THRESHOLD                  31
#define MULLO_MUL_N_THRESHOLD            14709

#define DC_DIV_QR_THRESHOLD                 53
#define DC_DIVAPPR_Q_THRESHOLD             230
#define DC_BDIV_QR_THRESHOLD                50
#define DC_BDIV_Q_THRESHOLD                136

#define INV_MULMOD_BNM1_THRESHOLD           78
#define INV_NEWTON_THRESHOLD               202
#define INV_APPR_THRESHOLD                 202

#define BINV_NEWTON_THRESHOLD              236
#define REDC_1_TO_REDC_N_THRESHOLD          55

#define MU_DIV_QR_THRESHOLD               1442
#define MU_DIVAPPR_Q_THRESHOLD            1652
#define MUPI_DIV_QR_THRESHOLD               81
#define MU_BDIV_QR_THRESHOLD              1787
#define MU_BDIV_Q_THRESHOLD               1685

#define POWM_SEC_TABLE  1,22,194,376,692,2657

#define MATRIX22_STRASSEN_THRESHOLD         21
#define HGCD_THRESHOLD                      85
#define HGCD_APPR_THRESHOLD                 50
#define HGCD_REDUCE_THRESHOLD             4455
#define GCD_DC_THRESHOLD                   456
#define GCDEXT_DC_THRESHOLD                345
#define JACOBI_BASE_METHOD                   4

#define GET_STR_DC_THRESHOLD                17
#define GET_STR_PRECOMPUTE_THRESHOLD        27
#define SET_STR_DC_THRESHOLD               100
#define SET_STR_PRECOMPUTE_THRESHOLD       960

#define FAC_DSC_THRESHOLD                  208
#define FAC_ODD_THRESHOLD                   26
